TCLAP::MultiSwitchArg Class Reference

A multiple switch argument. More...

`#include <MultiSwitchArg.h>`

Inheritance diagram for TCLAP::MultiSwitchArg:
[legend]
Collaboration diagram for TCLAP::MultiSwitchArg:
[legend]

## Public Member Functions

| MultiSwitchArg (const std::string &flag, const std::string &name, const std::string &desc, int init=0, Visitor *v=NULL)
| MultiSwitchArg constructor. More...
| MultiSwitchArg (const std::string &flag, const std::string &name, const std::string &desc, CmdLineInterface &parser, int init=0, Visitor *v=NULL)
| MultiSwitchArg constructor. More...
virtual bool | processArg (int *i, std::vector< std::string > &args)
| Handles the processing of the argument. More...
int | getValue () const
| Returns int, the number of times the switch has been set. More...
std::string | shortID (const std::string &val) const
| Returns the shortID for this Arg. More...
std::string | longID (const std::string &val) const
| Returns the longID for this Arg. More...
void | reset ()
| Clears the Arg object and allows it to be reused by new command lines. More...
Public Member Functions inherited from TCLAP::SwitchArg
| SwitchArg (const std::string &flag, const std::string &name, const std::string &desc, bool def=false, Visitor *v=NULL)
| SwitchArg constructor. More...
| SwitchArg (const std::string &flag, const std::string &name, const std::string &desc, CmdLineInterface &parser, bool def=false, Visitor *v=NULL)
| SwitchArg constructor. More...
bool | combinedSwitchesMatch (std::string &combined)
| Checks a string to see if any of the chars in the string match the flag for this Switch. More...
bool | getValue () const
| Returns bool, whether or not the switch has been set. More...
| operator bool () const
| A SwitchArg can be used as a boolean, indicating whether or not the switch has been set. More...
Public Member Functions inherited from TCLAP::Arg
virtual | ~Arg ()
| Destructor. More...
virtual void | addToList (std::list< Arg * > &argList) const
| Adds this to the specified list of Args. More...
virtual bool | operator== (const Arg &a) const
| Operator ==. More...
const std::string & | getFlag () const
| Returns the argument flag. More...
const std::string & | getName () const
| Returns the argument name. More...
std::string | getDescription () const
| Returns the argument description. More...
virtual bool | isRequired () const
| Indicates whether the argument is required. More...
void | forceRequired ()
| Sets _required to true. More...
void | xorSet ()
| Sets the _alreadySet value to true. More...
bool | isValueRequired () const
| Indicates whether a value must be specified for argument. More...
bool | isSet () const
| Indicates whether the argument has already been set. More...
bool | isIgnoreable () const
| Indicates whether the argument can be ignored, if desired. More...
virtual bool | argMatches (const std::string &s) const
| A method that tests whether a string matches this argument. More...
virtual std::string | toString () const
| Returns a simple string representation of the argument. More...
virtual void | trimFlag (std::string &flag, std::string &value) const
| Trims a value off of the flag. More...
bool | _hasBlanks (const std::string &s) const
| Checks whether a given string has blank chars, indicating that it is a combined SwitchArg. More...
void | setRequireLabel (const std::string &s)
| Sets the requireLabel. More...
virtual bool | allowMore ()
| Used for MultiArgs and XorHandler to determine whether args can still be set. More...
virtual bool | acceptsMultipleValues ()
| Use by output classes to determine whether an Arg accepts multiple values. More...

## Protected Attributes

int | _value
| The value of the switch. More...
int | _default
| Used to support the reset() method so that ValueArg can be reset to their constructed value. More...
Protected Attributes inherited from TCLAP::SwitchArg
bool | _value
| The value of the switch. More...
bool | _default
| Used to support the reset() method so that ValueArg can be reset to their constructed value. More...
Protected Attributes inherited from TCLAP::Arg
std::string | _flag
| The single char flag used to identify the argument. More...
std::string | _name
| A single word namd identifying the argument. More...
std::string | _description
| Description of the argument. More...
bool | _required
| Indicating whether the argument is required. More...
std::string | _requireLabel
| Label to be used in usage description. More...
bool | _valueRequired
| Indicates whether a value is required for the argument. More...
bool | _alreadySet
| Indicates whether the argument has been set. More...
Visitor * | _visitor
| A pointer to a visitor object. More...
bool | _ignoreable
| Whether this argument can be ignored, if desired. More...
bool | _xorSet
| Indicates that the arg was set as part of an XOR and not on the command line. More...
bool | _acceptsMultipleValues

## Additional Inherited Members

Static Public Member Functions inherited from TCLAP::Arg
static void | beginIgnoring ()
| Begin ignoring arguments since the "--" argument was specified. More...
static bool | ignoreRest ()
| Whether to ignore the rest. More...
static char | delimiter ()
| The delimiter that separates an argument flag/name from the value. More...
static char | blankChar ()
| The char used as a place holder when SwitchArgs are combined. More...
static char | flagStartChar ()
static const std::string | flagStartString ()
static const std::string | nameStartString ()
static const std::string | ignoreNameString ()
| The name used to identify the ignore rest argument. More...
static void | setDelimiter (char c)
| Sets the delimiter for all arguments. More...
Protected Member Functions inherited from TCLAP::Arg
void | _checkWithVisitor () const
| Performs the special handling described by the Visitor. More...
| Arg (const std::string &flag, const std::string &name, const std::string &desc, bool req, bool valreq, Visitor *v=NULL)
| Primary constructor. More...

## Detailed Description

A multiple switch argument.

If the switch is set on the command line, then the getValue method will return the number of times the switch appears.

Definition at line 42 of file MultiSwitchArg.h.

## Constructor & Destructor Documentation

## MultiSwitchArg() [1/2]

TCLAP::MultiSwitchArg::MultiSwitchArg | ( | const std::string & | flag,
|  | const std::string & | name,
|  | const std::string & | desc,
|  | int | init = `0`,
|  | Visitor * | v = `NULL`
| ) |  |

inline

MultiSwitchArg constructor.

Parameters

  flag | - The one character flag that identifies this argument on the command line.
  name | - A one word name for the argument. Can be used as a long flag on the command line.
  desc | - A description of what the argument is for or does.
  init | - Optional. The initial/default value of this Arg. Defaults to 0.
  v | - An optional visitor. You probably should not use this unless you have a very good reason.

Definition at line 133 of file MultiSwitchArg.h.

## MultiSwitchArg() [2/2]

TCLAP::MultiSwitchArg::MultiSwitchArg | ( | const std::string & | flag,
|  | const std::string & | name,
|  | const std::string & | desc,
|  | CmdLineInterface & | parser,
|  | int | init = `0`,
|  | Visitor * | v = `NULL`
| ) |  |

inline

MultiSwitchArg constructor.

Parameters

  flag | - The one character flag that identifies this argument on the command line.
  name | - A one word name for the argument. Can be used as a long flag on the command line.
  desc | - A description of what the argument is for or does.
  parser | - A CmdLine parser object to add this Arg to
  init | - Optional. The initial/default value of this Arg. Defaults to 0.
  v | - An optional visitor. You probably should not use this unless you have a very good reason.

Definition at line 143 of file MultiSwitchArg.h.

References TCLAP::CmdLineInterface::add().

Here is the call graph for this function:

## Member Function Documentation

## getValue()

int TCLAP::MultiSwitchArg::getValue | ( |  | ) | const

inline

Returns int, the number of times the switch has been set.

Definition at line 114 of file MultiSwitchArg.h.

References _value.

## longID()

std::string TCLAP::MultiSwitchArg::longID | ( | const std::string & | val | ) | const

inlinevirtual

Returns the longID for this Arg.

Reimplemented from TCLAP::Arg.

Definition at line 200 of file MultiSwitchArg.h.

References TCLAP::Arg::longID().

Here is the call graph for this function:

## processArg()

bool TCLAP::MultiSwitchArg::processArg | ( | int * | i,
|  | std::vector< std::string > & | args
| ) |  |

inlinevirtual

Handles the processing of the argument.

This re-implements the SwitchArg version of this method to set the _value of the argument appropriately.

Parameters

  i | - Pointer the the current argument in the list.
  args | - Mutable list of strings. Passed in from main().

Reimplemented from TCLAP::SwitchArg.

Definition at line 156 of file MultiSwitchArg.h.

References TCLAP::Arg::_alreadySet, TCLAP::Arg::_checkWithVisitor(), TCLAP::Arg::_ignoreable, _value, TCLAP::Arg::argMatches(), TCLAP::SwitchArg::combinedSwitchesMatch(), and TCLAP::Arg::ignoreRest().

Here is the call graph for this function:

## reset()

void TCLAP::MultiSwitchArg::reset | ( |  | ) |

inlinevirtual

Clears the Arg object and allows it to be reused by new command lines.

Reimplemented from TCLAP::SwitchArg.

Definition at line 206 of file MultiSwitchArg.h.

References _default, and _value.

## shortID()

std::string TCLAP::MultiSwitchArg::shortID | ( | const std::string & | val | ) | const

inlinevirtual

Returns the shortID for this Arg.

Reimplemented from TCLAP::Arg.

Definition at line 194 of file MultiSwitchArg.h.

References TCLAP::Arg::shortID().

Here is the call graph for this function:

## Member Data Documentation

## _default

int TCLAP::MultiSwitchArg::_default

protected

Used to support the reset() method so that ValueArg can be reset to their constructed value.

Definition at line 55 of file MultiSwitchArg.h.

Referenced by reset().

## _value

int TCLAP::MultiSwitchArg::_value

protected

The value of the switch.

Definition at line 49 of file MultiSwitchArg.h.

Referenced by getValue(), processArg(), and reset().

The documentation for this class was generated from the following file:

- MultiSwitchArg.h